Subject: Re: [rfc-i] Proposed survey on I-D authoring tools

From: Loa Andersson <[email-masked]>
Date: Thu, 1 Oct 2020 15:42:47 +0800

Jay,

while I can understand that it is "a good thing" to understand what 
formats and tools is used to author I-Ds, it does not fully answer the 
question why this survey is done.

Once we know "formats and tools" what will this be used for?

/Loa

On 30/09/2020 10:58, Jay Daley wrote:
> We are planning to send out a survey on I-D authoring tools to authors and wider to provide information for a number of groups including RSOC, Tools Team, Tools Architecture and Strategy Team, and the LLC.  The proposed question plan is below and we would welcome any feedback.  In particular:
> 
> - are all the important questions asked?
> - are all the key tools / processes mentioned?
> - is the language clear including for those for whom English is not their first language?
> 
> thanks in advance
> Jay
> 
> 
> # Question Plan
> 
> [PAGE]
> Introduction
> 
> [HELPTEXT]
> Thank you for taking part in this survey.  This survey has been sent to everyone who has authored an Internet-Draft (I-D) in the last five years and is open to anyone who has ever authored an I-D.
> 
> We are hoping to understand what formats and tools you use to author I-Ds, from drafting to submission.
> 
> In particular, we are hoping to find out more about the use (or non-use) of the v3 XML format for I-Ds, which became the publication format for RFCs on 16 September 2019.
> 
> [QUESTION - Multiple Choice]
> Approximately, how many I-Ds have you authored in total (different I-Ds not versions of the same I-D)?
> If you need a reminder then your Datatracker page will have the details.
> 	• 0
> 	• 1-5
> 	• 6-10
> 	• 11-20
> 	• 21-50
> 	• 51+
> 
> [QUESTION - Matrix/Rating Scale]
> Approximately, how many times have you submitted a draft (both a new draft and a new version) to the Datatracker?
> Items
> 	• 0
> 	• 1-10
> 	• 11-20
> 	• 21-50
> 	• 50-100
> 	• 101+
> Scale
> 	• In total
> 	• Last 2 years (Since September 2018)
> 	• Last year (since September 2019)
> 
> [QUESTION - Multiple Choice]
> How many RFCs have you authored?
> 	• 0
> 	• 1-5
> 	• 6-10
> 	• 11-20
> 	• 21-50
> 	• 51+
> 
> 
> [PAGE]
> Drafting to submission
> 
> [LOGIC]
> Only get here if they have authored an I-D.
> 
> [QUESTION - Matrix/Rating Scale]
> How often have you used the following document format(s) and associated output process(es) (editor/template/converter) when authoring an I-D? (Ignore any you don’t know about)
> Items
> 	• Plain text using no markup
> 	• Plain text using a different output process
> 	• Markdown using the kramdown-rfc2629 converter
> 	• Markdown using the mmark converter
> 	• Markdown using the draftr converter
> 	• Markdown using the Pandoc2rfc converter
> 	• Markdown using a different output process
> 	• XML using the XMLMind editor and xml2rfc-xxe
> 	• XML using a different output process
> 	• AsciiDoc using the metanorma-ietf (formerly known as asciidoctor-rfc) converter
> 	• AsciiDoc using a different output process
> 	• TeX / LaTeX using Lyx editor and lyx2rfc
> 	• TeX / LaTeX using a different output process
> 	• nroff using the Nroff Edit editor
> 	• nroff using nroff2xml template
> 	• nroff using a different output process
> 	• Microsoft Word rich text using Joe Touch’s Word Template (RFC5385)
> 	• Microsoft Word rich text using a different output process (This means specifically using rich text styles that a template/convertor will recognise, it does not mean using this an editor for one of the other formats)
> 	• Other format (Only use this option if you author in a different format to all of those above) [PLEASE SPECIFY what format you author in and what output process you use]
> Scale
> 	• Always
> 	• Very often
> 	• Sometimes
> 	• Rarely
> 	• Never [Ensure this is scored as 0]
> 
> [QUESTION - Comment Box]
> If you answered “a different output process” in the question above then please specify what it is?
> 
> [QUESTION - Checkboxes]
> How did you choose the document format(s) and associated output process(es) that you use? (Check all that apply)
> 	• I researched the tools
> 	• I decided on my authoring format first and then chose a tool that uses that
> 	• I saw a presentation on one of the tools at an IETF meeting
> 	• Another author chose for me
> 	• The I-D I wanted to contribute to was already drafted in one of these tools
> 	• Other [PLEASE SPECIFY]
> 
> [QUESTION - Matrix/Rating Scale]
> How often have you used the following template(s) when drafting an I-D? (Ignore any you don’t know about)
> Items
> 	• A copy of a previous I-D / RFC
> 	• A template from https://tools.ietf.org/tools/templates/
> 	• A template that came with my chosen authoring tool/process
> 	• My own
> 	• Other [PLEASE SPECIFY]
> Scale
> 	• Always
> 	• Very often
> 	• Sometimes
> 	• Rarely
> 	• Never [Ensure this is scored as 0]
> 
> [QUESTION - Matrix/Rating Scale]
> How often have you used the following additional authoring tools? (Ignore any you don’t know about)
> Items
> 	• bibtext2rfc to convert bibtext citations into bibxml references
> 	• bibxml2md to convert bibxml references into markdown
> 	• Doublespace tool to change spacing between sentences to two spaces
> 	• id2xml to convert a plain text I-D into XML
> 	• idnits to check a draft before submission
> 	• idspell to check a draft for spelling errors
> 	• rfc2629xslt to convert RFC XML into another output format
> 	• RFC dependency checker
> 	• rfcdiff to find diffs between versions of drafts
> 	• svgcheck to check a draft for SVG schema compliance
> 	• xml2rfc validator to validate RFC XML
> Scale
> 	• Always
> 	• Very often
> 	• Sometimes
> 	• Rarely
> 	• Never [Ensure this is scored as 0]
> 
> [QUESTION - Checkboxes]
> How do you run your tools? (Check all that apply)
> 	• Locally
> 	• On a private hosted server
> 	• On an IETF public web service
> 	• On a third-party public web service
> 	• Using CI/CD with GitHub
> 	• Using CI/CD with Gitlab
> 	• Other [PLEASE SPECIFY]
> 
> 
> [PAGE]
> XML v3
> 
> [QUESTION - Multiple Choice]
> How do you rate your knowledge of the v3 official RFC/I-D XML format?
> 	• Excellent
> 	• Good
> 	• Fair
> 	• Poor
> 	• None
> 
> [QUESTION - Matrix/Rating Scale]
> How satisfied are you with the following characteristics of the v3 XML format?
> Items
> 	• Ease of use
> 	• Features
> 	• Documentation
> 	• Tools support
> 	• Other [PLEASE SPECIFY]
> Scale
> 	• Very satisfied
> 	• Satisfied
> 	• Neutral
> 	• Dissatisfied
> 	• Very dissatisfied
> 	• N/A
> 
> [QUESTION - Matrix/Rating Scale]
> How important are the following characteristics of the v3 XML format to you?
> Items
> 	• Ease of use
> 	• Features
> 	• Documentation
> 	• Tools support
> 	• Other [PLEASE SPECIFY]
> Scale
> 	• Very important
> 	• Important
> 	• Neutral
> 	• Unimportant
> 	• Very unimportant
> 	• N/A
> 
> [QUESTION - Comment Box]
> What more needs to be done to support the rollout of the v3 XML format?
> 
> 
> [PAGE]
> State of the current authoring tools landscape
> 
> [QUESTION - Matrix/Rating Scale]
> How satisfied are you with the following characteristics of authoring tools?
> Items
> 	• Ease of use
> 	• Integration with IETF processes
> 	• Support for the full range of tags / metadata
> 	• Control of output
> 	• Support of various output formats
> 	• Speed at which new features are added
> 	• Overall quality
> 	• Choice of different tools
> 	• Other [PLEASE SPECIFY]
> Scale
> 	• Very satisfied
> 	• Satisfied
> 	• Neutral
> 	• Dissatisfied
> 	• Very dissatisfied
> 	• N/A
> 
> [QUESTION - Matrix/Rating Scale]
> How Important are the following characteristics of authoring tools to you?
> Items
> 	• Ease of use
> 	• Integration with IETF processes
> 	• Support for the full range of tags / metadata
> 	• Control of output
> 	• Support of various output formats
> 	• Speed at which new features are added
> 	• Overall quality
> 	• Choice of different tools
> 	• Other [PLEASE SPECIFY]
> Scale
> 	• Very important
> 	• Important
> 	• Neutral
> 	• Not important
> 	• Not at all important
> 	• N/A
> 
> [QUESTION - Multiple Choice]
> Should the IETF invest in a new, modern toolchain for authoring drafts?
> 	• Strongly agree
> 	• Agree
> 	• Neutral
> 	• Disagree
> 	• Strongly disagree
> 
> [QUESTION - Matrix/Rating Scale]
> How important is it for you for any new tool to support the following authoring formats?
> Items
> 	• Markdown
> 	• XML
> 	• WYSIWYG
> 	• Other [PLEASE SPECIFY]
> Scale
> 	• Very important
> 	• Important
> 	• Neutral
> 	• Not important
> 	• Not at all important
> 	• N/A
> 
> [QUESTION - Comment Box]
> Do you have any more feedback on authoring tools and formats?
> 
> 
> 

-- 

Loa Andersson                        email: [email-masked]
Senior MPLS Expert                          [email-masked]
Bronze Dragon Consulting             phone: +46 739 81 21 64
_______________________________________________
rfc-interest mailing list
[email-masked]
https://www.rfc-editor.org/mailman/listinfo/rfc-interest

---

From: Michael Richardson <[email-masked]>
Date: Thu, 01 Oct 2020 10:03:22 -0400

Jay Daley <[email-masked]> wrote:
    >> On 1/10/2020, at 2:27 PM, Randy Bush <[email-masked]> wrote:
    >>
    >>> I’ve only mentioned an editor where it has specific functionality
    >>> (either in-built or via a plugin) to support I-D authoring.
    >>
    >> i guess you have never met emacs' xml mode

    > I wouldn’t describe that as specific functionality to support I-D
    > authoring.  An example of the what I mean is the xml2rfc-xxe plugin to
    > XMLMind, which is maintained by some IETF volunteers.

I think that there is a distinction between using notepad to edit XML,
vs you used vi/emacs/eclipse/textmate with an XML-specific (XML validating)
or RFC2629-specific editing mode.

emacs' xml-mode is a significantly better experience than emacs in text-mode.
(emacs defaults to 'docbook' mode for .xml, which is actually much worse than text-mode)

--
Michael Richardson <[email-masked]>   . o O ( IPv6 IøT consulting )
           Sandelman Software Works Inc, Ottawa and Worldwide

---

From: Jay Daley <[email-masked]>
Date: Fri, 2 Oct 2020 03:51:07 +1300

> On 2/10/2020, at 3:03 AM, Michael Richardson <[email-masked]> wrote:
> 
> 

Is there an RFC2629-specific editing mode?  If so then I want to capture that.  If all they are doing is using something like the RelaxNG schema to validate against then that should be captured (I may need to add the RelaxNG schema to the list of other tools).

Jay

-- 
Jay Daley
IETF Executive Director
[email-masked]

---

From: Jay Daley <[email-masked]>
Date: Fri, 2 Oct 2020 03:53:13 +1300

Hi Loa

There are three groups that can use the output of this survey for their work: RSOC, Tools Team and Tools Architecture and Strategy Team.  It’s up to them how to use it but having a sound evidential basis on which to act is preferable to the current situation.

Jay

> On 1/10/2020, at 8:42 PM, Loa Andersson <[email-masked]> wrote:
> 
> Jay,
> 
> while I can understand that it is "a good thing" to understand what formats and tools is used to author I-Ds, it does not fully answer the question why this survey is done.
> 
> Loa Andersson                        email: [email-masked] <mailto:[email-masked]>
> Senior MPLS Expert                          [email-masked] <mailto:[email-masked]>

-- 
Jay Daley
IETF Executive Director
[email-masked]

---

From: Randy Bush <[email-masked]>
Date: Thu, 01 Oct 2020 08:52:28 -0700

i started to wonder two things

what is all this about?  who actually wants this survey and why?

and, as you started it, jay, i wonder what toolchain you use to author
drafts?

randy

---

From: Carsten Bormann <[email-masked]>
Date: Thu, 1 Oct 2020 18:03:35 +0200

> Is there an RFC2629-specific editing mode?  If so then I want to capture that.  If all they are doing is using something like the RelaxNG schema to validate against then that should be captured (I…

When I was still using XML, I used emacs’ nxml-mode with the rfc2629.rnc schema (*).
I would expect most emacs-proficient users to arrive there.
This is not just about validating, but also being able to choose from valid next steps.  (Unfortunately, nxml-mode never became quite as efficient for keyboarding XML as previous SGML-modes were.)

Basically, you should orthogonalize:

— the authoring format (nroff, RFCXML, markdown, asciidoc, …)
- the tool used for editing that authoring format

Many of us have been using several tools on a common format.
(Much initial use of kramdown-rfc was to generate the tedious XML right from markdown keyboarding, BTW.  !}kramdown-rfc RET, if you use vi.)

Grüße, Carsten

(*) Actually, a slightly hacked one, but that was 2009, and I don’t remember the details.

---

From: Jay Daley <[email-masked]>
Date: Fri, 2 Oct 2020 05:13:00 +1300

> On 2/10/2020, at 4:52 AM, Randy Bush <[email-masked]> wrote:
> 

It started with an action I took in the most recent RSOC meeting to survey authors to understand choices on draft submission formats because those directly affect the work of the RPC which in turn affects the SLA and the contract cost.  The adoption of the v3 XML as the RFC publication format in September 2019 has meant a significant increase in costs as the RPC has to convert plain text or v2 XML submissions into v3.

In that context I was surprised to hear that a number of people author in XML and then use xml2rfc to convert to plain text and submit that plain text I-D.

After my first draft it became clear that this had to loop in the tools teams as the survey could not focus on formats without also covering tools as the two are so closely linked.

> and, as you started it, jay, i wonder what toolchain you use to author

The last time I authored a draft was in 2013 and I wrote that in XML using the OxygenXML commercial XML editor with xml2rfc to validate it. I don’t remember what format I used to submit it.  That draft btw was all about XML/XSLT.  https://datatracker.ietf.org/person/Jay%20Daley

Jay

-- 
Jay Daley
IETF Executive Director
[email-masked]

---

From: Michael Richardson <[email-masked]>
Date: Thu, 01 Oct 2020 12:45:19 -0400

Jay Daley <[email-masked]> wrote:
    >>> authoring.  An example of the what I mean is the xml2rfc-xxe plugin
    >>> to XMLMind, which is maintained by some IETF volunteers.
    >>
    >> vs you used vi/emacs/eclipse/textmate with an XML-specific (XML
    >> validating) or RFC2629-specific editing mode.

    > Is there an RFC2629-specific editing mode?

in emacs, no.
xml-mode knows a bit about DTDs though, I seem to think.
I can't speak for the other editors.

    > If so then I want to
    > capture that.  If all they are doing is using something like the
    > RelaxNG schema to validate against then that should be captured (I may
    > need to add the RelaxNG schema to the list of other tools).

--
]               Never tell me the odds!                 | ipv6 mesh networks [
]   Michael Richardson, Sandelman Software Works        |    IoT architect   [
]     [email-masked]  http://www.sandelman.ca/        |   ruby on rails    [

---

From: Randy Bush <[email-masked]>
Date: Thu, 01 Oct 2020 09:55:09 -0700

> I am not so sure what the value of asking what people do today is. The
> question that really matters is what people would do if they knew what
> all the options were.

actually, i don't really buy this.  what i use today differs from what i
use 10 or 20 years ago, and i presume similarly going forward.

what we have today, is close to a classic hourglass model, with an xml
waist.  you can produce that however the heck you want.  and there seems
to be a rich set of tools to produce the xml.  this seems a healthy
ecosystem to me.

and from the xml, the rfced can produce all the output formats.

some really sharp and hard-working folk have produced a rich ecosystem
of front ends.  this is great, as long as they are compatible with the
back end.

and we have a back end which is settling in from a major change.  i
suspect we may not want to 'fix' it right now.

hence my asking what all this is about.  i am trying to produce work,
not chase this week's fashion in editing/formatting.

randy

---

From: Jay Daley <[email-masked]>
Date: Fri, 2 Oct 2020 05:56:38 +1300

> On 2/10/2020, at 5:03 AM, Carsten Bormann <[email-masked]> wrote:
> 

Great.  I will add the RelaxNG schema to the list of additional validation tools.

> (Much initial use of kramdown-rfc was to generate the tedious XML right from markdown keyboarding, BTW.  !}kramdown-rfc RET, if you use vi.)

If we did ask it that way then we lose the important data of what format goes with what output process and it also gives us a lot of unnecessary noise about what editors people use.

In the end, this is not going to be a perfect survey as there are too many variable and too many unknowns.  

Jay

-- 
Jay Daley
IETF Executive Director
[email-masked]

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Thu, 1 Oct 2020 10:05:14 -0700

As the author of a tool that generates xml2rfc v3, I am also interested in the results of this survey.

-- 
Marc Petit-Huguenin
Email: [email-masked]
Blog: https://marc.petit-huguenin.org
Profile: https://www.linkedin.com/in/petithug

---

From: Jay Daley <[email-masked]>
Date: Fri, 2 Oct 2020 06:09:03 +1300

The updated survey is below.  Please note that 

- this doesn’t show the links
- I am still not sure how to point people to their Datatracker stats page
- the flow logic may change when the survey is tested.

Further feedback is most welcome.

Jay

# Question Plan

[PAGE] 
Introduction

[HELPTEXT]

[PAGE]
Drafting to submission

[LOGIC]

[QUESTION - Matrix/Rating Scale]
How often have you used the following document format(s) and associated output process(es) (editor/template/converter) when authoring an I-D? (Ignore any you don’t know about)
Items
	• Plain text using no markup
	• Plain text using a different output process
	• Markdown using the kramdown-rfc2629 converter
	• Markdown using the mmark converter
	• Markdown using the draftr converter
	• Markdown using the Pandoc2rfc converter
	• Markdown using a different output process
	• XML using the xml2rfc-xxe editor plugin
	• XML using xml2rfc to create plain text for submission
	• XML using a different output process
	• AsciiDoc using the metanorma-ietf (formerly known as asciidoctor-rfc) converter
	• AsciiDoc using a different output process
	• TeX / LaTeX using the lyx2rfc editor plugin
	• TeX / LaTeX using a different output process
	• nroff using the Nroff Edit editor
	• nroff using nroff2xml template
	• nroff using a different output process
	• .doc/.docx using Joe Touch’s Word Template (RFC5385)
	• .doc/.docx using a different output process (This means specifically using rich text styles that a template/convertor will recognise)
	• Other format (Only use this option if you author in a different format to all of those above) [PLEASE SPECIFY what format you author in and what output process you use]
Scale
	• Always
	• Very often
	• Sometimes
	• Rarely
	• Never [Ensure this is scored as 0]

[QUESTION - Comment Box]

[QUESTION - Checkboxes]
How did you choose the document format(s) and associated output process(es) that you use? (Check all that apply)
	• I researched the tools
	• I decided on my authoring format first and then chose a tool that uses that
	• I saw a presentation on one of the tools at an IETF meeting
	• Another author of my document chose for me
	• The I-D I wanted to contribute to was already drafted in one of these tools
	• Someone else helped me set up my tools
	• Other [PLEASE SPECIFY]

[QUESTION - Matrix/Rating Scale]
How often do you use the following checking tools? (Ignore any you don’t know about)
Items
	• I validate against the RelaxNG schema for the RFC XML in my XML editor 
	• Bill’s ABNF parser to check ABNF
	• idnits to check a draft before submission 
	• idspell to check a draft for spelling errors
	• pyang to check YANG modules
	• RFC dependency checker
	• rfcdiff to find diffs between versions of drafts
	• SMICng to check MIBs
	• smilint to check MIBs
	• svgcheck to check a draft for SVG schema compliance 
	• xml2rfc validator to validate RFC XML
	• YANG validator to check YANG modules
Scale
	• Always
	• Very often
	• Sometimes
	• Rarely
	• Never [Ensure this is scored as 0]

[QUESTION - Matrix/Rating Scale]
How often do you use the following conversion tools? (Ignore any you don’t know about)
Items
	• bibtext2rfc to convert bibtext citations into bibxml references
	• bibxml2md to convert bibxml references into markdown
	• Doublespace tool to change spacing between sentences to two spaces
	• id2xml to convert a plain text I-D into XML
	• rfc2629xslt to convert RFC XML to another format
	• xml2rfc to convert RFC XML to another format
Scale
	• Always
	• Very often
	• Sometimes
	• Rarely
	• Never [Ensure this is scored as 0]

[QUESTION - Checkboxes]

[QUESTION - Multiple Choice]
Do you run an automated build process?
	• Yes - I-D Template
	• Yes - Using GitHub CI/CD
	• Yes - Using Gitlab CI/CD
	• Yes - Using Jenkins
	• Yes - Using CircleCI
	• Yes - Other [PLEASE SPECIFY]
	• No

[PAGE]
XML v3

[QUESTION - Comment Box]

[PAGE]

	• Integration with version control systems

	• Integration with version control systems

[QUESTION - Matrix/Rating Scale]
How important is it for you for any new tool to support the following authoring formats? 
Items
	• Plain text
	• Markdown
	• XML
	• nroff
	• AsciiDoc
	• Some form of WYSIWYG (e.g. MS Word or LibreOffice)
	• Other [PLEASE SPECIFY]
Scale
	• Very important
	• Important
	• Neutral
	• Not important
	• Not at all important
	• N/A

[QUESTION - Comment Box]

-- 
Jay Daley
IETF Executive Director
[email-masked]

---

From: Randy Bush <[email-masked]>
Date: Thu, 01 Oct 2020 10:28:03 -0700

> In that context I was surprised to hear that a number of people author
> in XML and then use xml2rfc to convert to plain text and submit that
> plain text I-D.

as i do that, i assumed most people did :)

except for sean, of course, who still uses nroff :) :)

randy

---

From: Ted Lemon <[email-masked]>
Date: Thu, 1 Oct 2020 13:34:00 -0400

> as i do that, i assumed most people did :)

Same. Emacs has a pretty good XML validator.

---

From: "Salz, Rich" <[email-masked]>
Date: Thu, 1 Oct 2020 19:19:41 +0000

I think it will be useful to know this kind of stuff, and folks must recognize it's a "point in time" status.

I worry about how long it will take to do the survey, but c'est la vie.

On 10/1/20, 1:09 PM, "Jay Daley" <[email-masked]> wrote:

    Jay

    # Question Plan

    [PAGE] 
    Introduction

    [HELPTEXT]

    [PAGE]
    Drafting to submission

    [LOGIC]

    [QUESTION - Comment Box]

    [QUESTION - Checkboxes]

    	• A template from https://urldefense.proofpoint.com/v2/url?u=https-3A__tools.ietf.org_tools_templates_&d=DwIGaQ&c=96ZbZZcaMF4w0F4jpN6LZg&r=4LM0GbR0h9Fvx86FtsKI-w&m=xVHNxz6VGHMvSCNgEu_8tuBVqta0NSRyqdqKWHi40mo&s=DSnQGm6Hyl9_OfYe6k4icoHs57aG-7m1z883qZRIVYM&e=  

    [QUESTION - Checkboxes]

    [PAGE]
    XML v3

    [QUESTION - Comment Box]

    [PAGE]

    [QUESTION - Comment Box]

    -- 
    Jay Daley
    IETF Executive Director
    [email-masked]

    ___________________________________________________________
    Tools-discuss mailing list
    [email-masked]
    https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_mailman_listinfo_tools-2Ddiscuss&d=DwIGaQ&c=96ZbZZcaMF4w0F4jpN6LZg&r=4LM0GbR0h9Fvx86FtsKI-w&m=xVHNxz6VGHMvSCNgEu_8tuBVqta0NSRyqdqKWHi40mo&s=IClP4a41N1JspVd_SfEh2fZUdJ0sZGo86bjQaPPWsfE&e= 

    Please report datatracker.ietf.org and mailarchive.ietf.org
    bugs at https://urldefense.proofpoint.com/v2/url?u=http-3A__tools.ietf.org_tools_ietfdb&d=DwIGaQ&c=96ZbZZcaMF4w0F4jpN6LZg&r=4LM0GbR0h9Fvx86FtsKI-w&m=xVHNxz6VGHMvSCNgEu_8tuBVqta0NSRyqdqKWHi40mo&s=i5rznLdvxJkg5w8D-bVLZ8y7-yi7o2X3opal9vPIlOE&e= 
    or send email to [email-masked]

    Please report tools.ietf.org bugs at
    https://urldefense.proofpoint.com/v2/url?u=http-3A__tools.ietf.org_tools_issues&d=DwIGaQ&c=96ZbZZcaMF4w0F4jpN6LZg&r=4LM0GbR0h9Fvx86FtsKI-w&m=xVHNxz6VGHMvSCNgEu_8tuBVqta0NSRyqdqKWHi40mo&s=63Mz1exu5UWe_yZecJIBR0XSFuZeFruwNhEjH8PjKbM&e= 
    or send email to [email-masked]

---

From: Jay Daley <[email-masked]>
Date: Fri, 2 Oct 2020 09:21:39 +1300

It was on there with pretty much that wording but in response to feedback I changed it to just "XML using the xml2rfc-xxe editor plugin" - does that work or should I revert? 

> On 2/10/2020, at 9:17 AM, Warren Kumari <[email-masked]> wrote:
> 
> Can we add: XMLMind with the xml2rfc-xxe plugin
> to the "document format(s) and associated output process(es)" list?
> 
> This plugin was originally created by Billo, and I took over
> maintenance many years back I don't know how many people still use it,
> but there are howls of outrage everytime a new version of XMLMind
> comes out and I don't release a new version in time.
> This will at least help me know if it is still worth my time to rev
> and post it...
> 
> W
> 
> On Thu, Oct 1, 2020 at 1:09 PM Jay Daley <[email-masked]> wrote:
>> 
>> https://www.ietf.org/mailman/listinfo/tools-discuss
>> 
>> bugs at http://tools.ietf.org/tools/ietfdb
>> http://tools.ietf.org/tools/issues
> I don't think the execution is relevant when it was obviously a bad
> idea in the first place.
> This is like putting rabid weasels in your pants, and later expressing
> regret at having chosen those particular rabid weasels and that pair
> of pants.
>   ---maf
> 

-- 
Jay Daley
IETF Executive Director
[email-masked]

---

From: "Andrew G. Malis" <[email-masked]>
Date: Thu, 1 Oct 2020 19:06:43 -0400

Randy and Jay,

There's one thing that I think the current ecosystem is missing that I
would really enjoy using. As I've been writing RFCs and drafts since the
1980s, you can guess that I've used a whole bunch of different tools,
including editing raw NROFF, editing raw XMLv2 (I haven't yet tried that
with XMLv3), using the Word template, and so on. What I've settled on at
the moment is writing in Kramdown, which lets me concentrate more on the
content than on the formatting.

However, the one sourcing tool that I really enjoyed (and really miss) is
nroffedit, which had two sides on the display, one showing the raw nroff
and the other showing WYSIWYG formatted text, and both windows were
instantly and synchronously updated as you edited in either. Having such a
tool for either XMLv3 or Kramdown would be awesome!

Cheers,
Andy

---

From: Randy Bush <[email-masked]>
Date: Thu, 01 Oct 2020 16:14:42 -0700

> However, the one sourcing tool that I really enjoyed (and really miss)
> is nroffedit, which had two sides on the display, one showing the raw
> nroff and the other showing WYSIWYG formatted text, and both windows
> were instantly and synchronously updated as you edited in either.

funny.  no desire.  well, maybe for complex tables or similar kink.

but when i am writing prose, i am focused on the wording, happy that
emacs sprinkles the <t> et alia, and i clean it up later.  it's
sufficiently hard to get clear and concise text, that i focus on it.

in the hope it makes rfced's life a micro easier, i do put in time later
to make pretty xml; probably much more than i should.  i doubt a wysiwyg
display would help.  the major issue in prettification is bracketing;
and emacs rulz.

randy

---

From: Donald Eastlake <[email-masked]>
Date: Thu, 1 Oct 2020 19:16:28 -0400

I use raw nroff and produce the input with emacs in nroff mode.

Thanks,
Donald

---

From: Randy Bush <[email-masked]>
Date: Thu, 01 Oct 2020 16:18:01 -0700

> I use raw nroff and produce the input with emacs in nroff mode.

surely there is someone even more primitive than we who does it
with a stone xml tablet and a chisel :)
_______________________________________________
rfc-interest mailing list
[email-masked]
https://www.rfc-editor.org/mailman/listinfo/rfc-interest

---

From: Ronald Tse <[email-masked]>
Date: Fri, 2 Oct 2020 06:29:24 +0000

I imagine the stone XML tablet will not be easy to edit (the chisel could erase, too!).

Jay, we are the people behind metanorma-ietf and AsciiRFC.  This is a timely and important survey indeed — thanks!

I have two questions:

1. Would it be possible to rephrase the particular choice of:
"AsciiDoc using the metanorma-ietf (formerly known as asciidoctor-rfc) converter”

to:

"AsciiDoc using Metanorma / AsciiRFC”
?

2. For the question on "How often do you use the following checking tools? (Ignore any you don’t know about)”

Can we add an option like:

“I don’t know; my authoring tool seems to do that for me"

Ron

_____________________________________

Ronald Tse
Ribose Inc.

On Oct 2, 2020, at 7:18 AM, Randy Bush <[email-masked]<mailto:[email-masked]>> wrote:

[email-masked]<mailto:[email-masked]>

---

From: Jay Daley <[email-masked]>
Date: Fri, 2 Oct 2020 21:41:07 +1300

Hi Ronald

> On 2/10/2020, at 7:29 PM, Ronald Tse <[email-masked]> wrote:
> 

Thank you too.

> "AsciiDoc using Metanorma / AsciiRFC”

I’m happy to add the 'AsciiRFC' part but is there a reason you want the ' (formerly known as asciidoctor-rfc) ' removed?

> “I don’t know; my authoring tool seems to do that for me"

Unfortunately this doesn’t really make sense as an additional option for that question.  It’s a matrix question where people answer each of the options with one of

 	• Always
   	• Very often
   	• Sometimes
   	• Rarely

Also, I don’t understand how this benefits us as the respondents may or may not have a built-in checker they don’t know about - can you explain the thinking behind it?

cheers
Jay

>> On Oct 2, 2020, at 7:18 AM, Randy Bush <[email-masked] <mailto:[email-masked]>> wrote:
>> 
>> [email-masked] <mailto:[email-masked]>

-- 
Jay Daley
IETF Executive Director
[email-masked]

---

From: Julian Reschke <[email-masked]>
Date: Fri, 2 Oct 2020 13:08:30 +0200

Am 02.10.2020 um 01:06 schrieb Andrew G. Malis:
> were instantly and synchronously updated as you edited in either. Having
> such a tool for either XMLv3 or Kramdown would be awesome!
> ...

The "live refresh" mode of rfc2629.xslt is very close to that.

See
<https://greenbytes.de/tech/webdav/rfc2629xslt/rfc2629xslt.html#html.live.refresh>.

Best regards, Julian

---

From: tom petch <[email-masked]>
Date: Fri, 2 Oct 2020 17:28:22 +0100

Jay

Perhaps they do not know what they are doing.  Perhaps I do not know what
I am doing!  I am a very occasional submitter.  I edit in plain text 
(Wordpad), usually starting with a previous submission so much of the 
XML is there, add new XML as needed (YANG made me comfortable with XML) 
and then go to datatracker submit which rejects me a few times for 
syntax errors after which I succeed and get an e-mail to tell me so.

I have always assumed that it is the XML that is submitted but your 
statement makes me wonder if in fact I am submitting plain text.  I do 
not know, I cannot tell.  I do not know what box to tick in the 
questionaire. Plain text with XML markup and datatracker submit '.xml 
format'.

Tom Petch

---

From: Randy Bush <[email-masked]>
Date: Fri, 02 Oct 2020 14:41:14 -0700

> questionaire. Plain text with XML markup and datatracker submit '.xml

fellow routing researchers used to tell me that the topology obeyed some
simple rules (known as gao rexford).  i insisted that, for the most
part, reality was not so simple.  for years it was almost a war.

finally, one researcher measured it, and indeed, 65% of the topology
was not obeying those simple rules.

her conclusion was that all those hundreds of configuration knobs were
there because someone wanted each and every one enough that vendors
implemented them.  and so each and every one was used.

i presume i do not need to explain the analogy.

randy

---

From: "Andrew G. Malis" <[email-masked]>
Date: Fri, 2 Oct 2020 18:49:54 -0400

Julian,

Thanks, I'll have to check that out!

Cheers,
Andy

On Fri, Oct 2, 2020 at 7:08 AM Julian Reschke <[email-masked]> wrote:

> <
> https://greenbytes.de/tech/webdav/rfc2629xslt/rfc2629xslt.html#html.live.refresh
> >.
>
> Best regards, Julian

---

From: Ronald Tse <[email-masked]>
Date: Sat, 3 Oct 2020 03:22:52 +0000

Hi Jay,

Please find my replies inline. Thanks!

Our original 'asciidoctor-rfc’ only generates XML RFC v2 (and the pre-release version of v3), and has been superseded by Metanorma for nearly 2 years.

  • Always
    • Very often
    • Sometimes
    • Rarely

I took the intent of this question as to gauge whether XML RFCs submitted were valid upon submission. If most submissions were not validated prior (e.g. authors like using the submission process for validation), then the RPC presumably needs more resourcing to reject invalid ones. On the other hand, if most submissions were already valid, resourcing is less of a concern.

For example, a typical Metanorma user may not be aware of the exact validation tools used mentioned in this question. One may put “Never” as they might not have ever heard of these validation tools. However, they do know that Metanorma helps them validate the file (by the output and warnings), but not sure what exactly that process entails.

Therefore the option of “I don’t know, my authoring tool seems to do that for me” rescues them from the “Never” bucket — otherwise the answers may be skewed.

Kind regards,
Ron

---

From: Jay Daley <[email-masked]>
Date: Mon, 5 Oct 2020 12:13:19 +1300

Thanks Ronald

> On 3/10/2020, at 4:22 PM, Ronald Tse <[email-masked]> wrote:
> 
> Hi Jay,
> 

As you’ve probably read, there are people still using stone tablets so two years is like a blink of the eye here. I’ll keep in the '(formerly known as asciidoctor-rfc)' just to help those who are versionally* challenged.

* I made 'versionally' up but I think it works.

> Therefore the option of “I don’t know, my authoring tool seems to do that for me” rescues them from the “Never” bucket — otherwise the answers may be skewed.

First, just to be clear - I’ve bundled all checking/validation tools together but you’re only talking about validating the XML, not validating YANG, ABNF etc, and so you only mean to see if Metanorma reduces the need for xml2rfc as a validator?  I’m checking this, because if that is the case then this extra option doesn’t make sense to add for all those other validators.

Second, I must admit that I assumed that only valid XML was accepted and I need to check exactly what happens there.  If not then yes that will have an impact on resources.  However, that’s not the intent of the question, which is to understand what tools people use and adding this doesn’t fit with that intent.  

To get at what you have identified here, I could add a question similar to this:

"How do you ensure that your draft is correctly formatted/validated when you submit it? (check all that apply)"
- I use the checkers/validators in the question above
- This is a feature of my authoring tool
- I submit my draft and correct any errors if it is rejected [Remove if invalid drafts are accepted]
- I don’t ensure that my draft is correctly formatted  [Remove if only valid drafts are accepted}
- Other [PLEASE SPECIFY]

Thoughts?

BTW if you want to know if people only use Metanorma then I can filter for that and I’ve also got a general action to safely release survey data, so this could be the first of those to allow people to understand the results in more depth.

Jay

-- 
Jay Daley
IETF Executive Director
[email-masked]

---

From: Ronald Tse <[email-masked]>
Date: Mon, 5 Oct 2020 01:37:30 +0000

Hi Jay,

I realized after my response the survey is intended to gather information for some period of history so you’re absolutely right about the first. Please feel free to keep the original for the “versionally” challenged!

Metanorma does not reduce the need for xml2rfc as the authoritative validator, it simply provides most of the validation beforehand to prevent issues with xml2rfc.

It seems that the question here assumes that machine-readable semantics inside an I-D/RFC can be validated (YANG, ABNF, etc.). This would be the case if the author(s) was originally told to do so, but existing cases may be tricky. For example, RFC 5545 (iCalendar) splits its ABNF into separate clauses for easier reading. In order for validation to happen, we’re looking at a monolithic piece of ABNF. Moreover, some I-D/RFCs also contain other types of content (XML, JSON, C…). It would certainly be a good approach if enforced in the future.

Your proposed question would certainly address my concerns, thank you!

BTW if you want to know if people only use Metanorma then I can filter for that[…]

There’s no particular need for that — thanks!

Kind regards,
Ron

Ronald Tse
Ribose Inc.

Thoughts?

Jay

Kind regards,
Ron

--
Jay Daley
IETF Executive Director
[email-masked]<mailto:[email-masked]>

---

From: Warren Kumari <[email-masked]>
Date: Thu, 1 Oct 2020 16:17:09 -0400

W

---

From: Warren Kumari <[email-masked]>
Date: Fri, 2 Oct 2020 19:54:22 -0400

On Thu, Oct 1, 2020 at 4:21 PM Jay Daley <[email-masked]> wrote:

> It was on there with pretty much that wording but in response to feedback
> I changed it to just "XML using the xml2rfc-xxe editor plugin" - does that
> work or should I revert?
>

Good lord, I *swear* I read that list multiple times and it wasn’t there....

Any wording is fine.

<blush>
Sorry,
W

> Thank you for taking part in this survey.  This survey has been sent to
> everyone who has authored an Internet-Draft (I-D) in the last five years
> and is open to anyone who has ever authored an I-D.
>
> In particular, we are hoping to find out more about the use (or non-use)
> of the v3 XML format for I-Ds, which became the publication format for RFCs
> on 16 September 2019.
>
> How often have you used the following document format(s) and associated
> output process(es) (editor/template/converter) when authoring an I-D?
> (Ignore any you don’t know about)
> Items
>        • .doc/.docx using a different output process (This means
> specifically using rich text styles that a template/convertor will
> recognise)
>        • Other format (Only use this option if you author in a different
> format to all of those above) [PLEASE SPECIFY what format you author in and
> what output process you use]
> Scale
>        • Always
>        • Very often
>        • Sometimes
>        • Rarely
> How did you choose the document format(s) and associated output
> process(es) that you use? (Check all that apply)
>        • I researched the tools
I don't think the execution is relevant when it was obviously a bad idea in
the first place.
This is like putting rabid weasels in your pants, and later expressing
regret at having chosen those particular rabid weasels and that pair of
pants.
   ---maf
_______________________________________________
rfc-interest mailing list
[email-masked]
https://www.rfc-editor.org/mailman/listinfo/rfc-interest